#! /usr/bin/make -f

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DATE=$(firstword $(subst +~, ,$(subst ., ,$(VERSION))))
SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)
SUITE=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2)

# Special treatment for kali-dev/kali-rolling/kali-experimental
ifneq ($(filter kali-rolling kali-dev kali-experimental,$(SUITE)),)
ifeq ($(SUITE),kali-experimental)  # Enable experimental repo
USE_KALI_EXPERIMENTAL=1
endif
SUITE=kali-rolling
USE_UDEBS_FROM=kali-rolling
TRANSSTATUS=
BOOTMENU_BEEP=y
else
# Daily builds vs. uploads to unstable:
ifeq (${SUITE},UNRELEASED)
USE_UDEBS_FROM=kali-rolling
TRANSSTATUS=
BOOTMENU_BEEP=n
else
USE_UDEBS_FROM=trixie
USE_PROPOSED_UPDATES=0
TRANSSTATUS=translation-status
BOOTMENU_BEEP=y
endif
endif

PRESEED ?= preseed.cfg

# Don't integrate SSL certs in armel, the size limits will be missed
ifeq ($(ARCH),armel)
SSL_CERTS=
else
SSL_CERTS=/usr/share/ca-certificates/mozilla/*
endif

# Adjust for non-released ports if needed:
RELEASE_ARCHES=amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el riscv64 s390x
ifeq (,$(filter $(ARCH), $(RELEASE_ARCHES)))
USE_UNRELEASED=1
USE_UDEBS_FROM=unstable
USE_PROPOSED_UPDATES=0
endif

# allow these aspects of the build to be overriden (see salsa-ci.yml)
BUILD_TARGETS ?= all_build stats release
ADDITIONAL_BUILD_PRODUCT ?= tarball

ARCHIVEDIR=debian/tmp/installer-$(ARCH)
DESTDIR=$(ARCHIVEDIR)/$(DATE)
IMAGEDIR=$(DESTDIR)/images
TARNAME=debian-installer-images_$(VERSION)_$(ARCH).tar.gz

export SOURCE_DATE_EPOCH

build/kali-mirror:
	# Use repo.kali.org when it's accessible, otherwise fallback to
	# public server
	if wget -q -O/dev/null http://repo.kali.org/kali; then \
		echo "http://repo.kali.org/kali" >build/kali-mirror; \
	else \
		echo "http://http.kali.org/kali" >build/kali-mirror; \
	fi

clean:
	dh_testdir
	dh_testroot
	dh_clean
	$(MAKE) -C build reallyclean
	$(MAKE) -C doc/devel/partman clean
	$(MAKE) -C doc/devel/internals clean

# Must run as root, so is not run as part of regular build.
build-images: build/kali-mirror
ifeq ($(SSL_CERTS),)
	# Drop wget-udeb only needed for SSL certs
	sed -i -e '/^wget-udeb/ d' build/pkg-lists/base
endif
	$(MAKE) -C build $(BUILD_TARGETS) \
		USE_UDEBS_FROM=$(USE_UDEBS_FROM) BUILD_DATE=$(DATE) \
		USE_PROPOSED_UPDATES=$(USE_PROPOSED_UPDATES) \
		USE_UNRELEASED=$(USE_UNRELEASED) \
		USE_KALI_EXPERIMENTAL=$(USE_KALI_EXPERIMENTAL) \
		PRESEED=$(PRESEED) \
		$(addprefix LINUX_KERNEL_ABI=,$(LINUX_KERNEL_ABI)) \
		TRANSSTATUS=$(TRANSSTATUS) BOOTMENU_BEEP=$(BOOTMENU_BEEP) \
		SSL_CERTS=$(SSL_CERTS)

publish-tarball:
	./build/util/gen-tarball debian/tmp ../$(TARNAME)
	dpkg-distaddfile $(TARNAME) raw-installer -

publish-miniiso:
	cp ./build/tmp/netboot-gtk/mini.iso ../debian-$(VERSION)-$(ARCH)-gtkmini.iso

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp:
	rm -f $@
	$(MAKE) -C doc/devel/internals
	$(MAKE) -C doc/devel/partman
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	debian/rules build-images

	install -d $(IMAGEDIR)
	cp -a build/dest/* $(IMAGEDIR)
	ln -s $(DATE) $(ARCHIVEDIR)/current

binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs doc/* -X Makefile -X build.sh -X .xsl \
		-X internals.xml -X partman-doc.dbk -X .gitignore
	dh_compress
	dh_fixperms

	./build/util/write-built-using

	dh_gencontrol
	dh_md5sums
	dh_builddeb

	debian/rules publish-$(ADDITIONAL_BUILD_PRODUCT)

binary-indep:

binary: binary-indep binary-arch
.PHONY: build build-images clean binary-indep binary-arch binary install
